Index: python/DelphesAnalysis/Delphes.py
===================================================================
--- python/DelphesAnalysis/Delphes.py	(revision a190d94a74b718659401449a3734834a40c0548d)
+++ python/DelphesAnalysis/Delphes.py	(revision 407aebaa4f2875ee1ee9de64f0160625d67bb1be)
@@ -12,5 +12,8 @@
   return theString
 
-_root.MakeRootClass( "Event" ).__str__    = _Event__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "Event" ).__str__    = _Event__str__
+else:
+  _root.CreateScopeProxy( "Event" ).__str__    = _Event__str__
 
 def _LHCOEvent__str__( self ):
@@ -18,5 +21,8 @@
   return theString
 
-_root.MakeRootClass( "LHCOEvent" ).__str__    = _LHCOEvent__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "LHCOEvent" ).__str__    = _LHCOEvent__str__
+else:
+  _root.CreateScopeProxy( "LHCOEvent" ).__str__    = _LHCOEvent__str__
 
 def _LHEFEvent__str__( self ):
@@ -28,5 +34,8 @@
   return hepmcstr
 
-_root.MakeRootClass( "LHEFEvent" ).__str__    = _LHEFEvent__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "LHEFEvent" ).__str__    = _LHEFEvent__str__
+else:
+  _root.CreateScopeProxy( "LHEFEvent" ).__str__    = _LHEFEvent__str__
 
 def _HepMCEvent__str__( self ):
@@ -43,5 +52,9 @@
   return hepmcstr
 
-_root.MakeRootClass( "HepMCEvent" ).__str__    = _HepMCEvent__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "HepMCEvent" ).__str__    = _HepMCEvent__str__
+else:
+  _root.CreateScopeProxy( "HepMCEvent" ).__str__    = _HepMCEvent__str__
+
 
 def _GenParticle__str__( self ):
@@ -61,5 +74,8 @@
   return thestring
 
-_root.MakeRootClass( "GenParticle" ).__str__    = _GenParticle__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "GenParticle" ).__str__    = _GenParticle__str__
+else:
+  _root.CreateScopeProxy( "GenParticle" ).__str__    = _GenParticle__str__
 
 def _GenParticle_printDecay( self, db, particles, pre="" ):
@@ -71,5 +87,8 @@
   return thestring
 
-_root.MakeRootClass( "GenParticle" ).printDecay = _GenParticle_printDecay
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "GenParticle" ).printDecay = _GenParticle_printDecay
+else:
+  _root.CreateScopeProxy( "GenParticle" ).printDecay = _GenParticle_printDecay
 
 def _MissingET__str__( self ):
@@ -77,11 +96,17 @@
   thestring += "Mising energy azimuthal angle: %f\n" % self.Phi
   return thestring
- 
-_root.MakeRootClass( "MissingET" ).__str__    = _MissingET__str__
+
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "MissingET" ).__str__    = _MissingET__str__
+else:
+  _root.CreateScopeProxy( "MissingET" ).__str__    = _MissingET__str__
 
 def _ScalarHT__str__( self ):
   thestring = "Scalar sum of transverse momenta: %f\n" %self.HT
 
-_root.MakeRootClass( "ScalarHT" ).__str__    = _ScalarHT__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "ScalarHT" ).__str__    = _ScalarHT__str__
+else:
+  _root.CreateScopeProxy( "ScalarHT" ).__str__    = _ScalarHT__str__
 
 def _Photon__str__( self ):
@@ -89,5 +114,8 @@
   return thestring
 
-_root.MakeRootClass( "Photon" ).__str__    = _Photon__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "Photon" ).__str__    = _Photon__str__
+else:
+  _root.CreateScopeProxy( "Photon" ).__str__    = _Photon__str__
 
 def _Electron__str__( self ):
@@ -96,5 +124,8 @@
   return thestring 
 
-_root.MakeRootClass( "Electron" ).__str__    = _Electron__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "Electron" ).__str__    = _Electron__str__
+else:
+  _root.CreateScopeProxy( "Electron" ).__str__    = _Electron__str__
 
 def _Muon__str__( self ):
@@ -103,5 +134,9 @@
   return thestring 
 
-_root.MakeRootClass( "Muon" ).__str__    = _Muon__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "Muon" ).__str__    = _Muon__str__
+else:
+  _root.CreateScopeProxy( "Muon" ).__str__    = _Muon__str__
+
 
 def _Jet__str__( self ):
@@ -126,5 +161,8 @@
   return thestring
 
-_root.MakeRootClass( "Jet" ).__str__    = _Jet__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "Jet" ).__str__    = _Jet__str__
+else:
+  _root.CreateScopeProxy( "Jet" ).__str__    = _Jet__str__
 
 def _Track__str__( self ):
@@ -137,5 +175,8 @@
   return thestring 
 
-_root.MakeRootClass( "Track" ).__str__    = _Track__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "Track" ).__str__    = _Track__str__
+else:
+  _root.CreateScopeProxy( "Track" ).__str__    = _Track__str__
 
 def _Tower__str__( self):
@@ -145,5 +186,8 @@
   return thestring
 
-_root.MakeRootClass( "Tower" ).__str__    = _Tower__str__
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "Tower" ).__str__    = _Tower__str__
+else:
+  _root.CreateScopeProxy( "Tower" ).__str__    = _Tower__str__
 
 #####################################################
@@ -156,5 +200,8 @@
   return theString
 
-_root.MakeRootClass( "TLorentzVector" ).__str__    = _lorentzVector__str__
-
-
+if hasattr(_root,"MakeRootClass"):
+  _root.MakeRootClass( "TLorentzVector" ).__str__    = _lorentzVector__str__
+else:
+  _root.CreateScopeProxy( "TLorentzVector" ).__str__    = _lorentzVector__str__
+
+