Index: trunk/src/BFieldProp.cc
===================================================================
--- trunk/src/BFieldProp.cc	(revision 434)
+++ trunk/src/BFieldProp.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,13 +20,13 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
Index: trunk/src/CaloUtil.cc
===================================================================
--- trunk/src/CaloUtil.cc	(revision 434)
+++ trunk/src/CaloUtil.cc	(revision 443)
@@ -1,11 +1,34 @@
-/*
-  ---- Delphes ----
-  A Fast Simulator for general purpose LHC detector
-  S. Ovyn ~~~~ severine.ovyn@uclouvain.be
-  
-  Center for Particle Physics and Phenomenology (CP3)
-  Universite Catholique de Louvain (UCL)
-  Louvain-la-Neuve, Belgium
-*/
+/***********************************************************************
+**                                                                    **
+**          /----------------------------------------------\          **
+**         |  Delphes, a framework for the fast simulation  |         **
+**         |       of a  generic collider experiment        |         **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
+**                                                                    **
+**                                                                    **
+**   This package uses:                                               **
+**   ------------------                                               **
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
+**   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
+**                                                                    **
+** ------------------------------------------------------------------ **
+**                                                                    **
+**   Main authors:                                                    **
+**   -------------                                                    **
+**                                                                    **
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
+**                                                                    **
+**                      Copyright (C) 2008-2009,                      **
+**                        All rights reserved.                        **
+**                                                                    **
+***********************************************************************/
 
 /// \file D_CaloUtil.cc
Index: trunk/src/FrogUtil.cc
===================================================================
--- trunk/src/FrogUtil.cc	(revision 434)
+++ trunk/src/FrogUtil.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 #include <iostream>
Index: trunk/src/HEPEVTConverter.cc
===================================================================
--- trunk/src/HEPEVTConverter.cc	(revision 434)
+++ trunk/src/HEPEVTConverter.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 #include <iostream>
Index: trunk/src/HepMCConverter.cc
===================================================================
--- trunk/src/HepMCConverter.cc	(revision 434)
+++ trunk/src/HepMCConverter.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 #include <iostream>
Index: trunk/src/JetsUtil.cc
===================================================================
--- trunk/src/JetsUtil.cc	(revision 434)
+++ trunk/src/JetsUtil.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,13 +20,13 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
Index: trunk/src/LHCOConverter.cc
===================================================================
--- trunk/src/LHCOConverter.cc	(revision 434)
+++ trunk/src/LHCOConverter.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,13 +20,13 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
Index: trunk/src/LHEFConverter.cc
===================================================================
--- trunk/src/LHEFConverter.cc	(revision 434)
+++ trunk/src/LHEFConverter.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 #include <iostream>
Index: trunk/src/PdgParticle.cc
===================================================================
--- trunk/src/PdgParticle.cc	(revision 434)
+++ trunk/src/PdgParticle.cc	(revision 443)
@@ -9,7 +9,9 @@
 **   This package uses:                                               **
 **   ------------------                                               **
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
 **   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
 **   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
Index: trunk/src/STDHEPConverter.cc
===================================================================
--- trunk/src/STDHEPConverter.cc	(revision 434)
+++ trunk/src/STDHEPConverter.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 #include <iostream>
Index: trunk/src/SmearUtil.cc
===================================================================
--- trunk/src/SmearUtil.cc	(revision 434)
+++ trunk/src/SmearUtil.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 /// \file SmearUtil.cc
Index: trunk/src/TreeClasses.cc
===================================================================
--- trunk/src/TreeClasses.cc	(revision 434)
+++ trunk/src/TreeClasses.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 #include "TreeClasses.h"
Index: trunk/src/TreeClassesLinkDef.h
===================================================================
--- trunk/src/TreeClassesLinkDef.h	(revision 434)
+++ trunk/src/TreeClassesLinkDef.h	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,16 +20,15 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
-
 
 #include "interface/TreeClasses.h"
Index: trunk/src/TriggerUtil.cc
===================================================================
--- trunk/src/TriggerUtil.cc	(revision 434)
+++ trunk/src/TriggerUtil.cc	(revision 443)
@@ -4,12 +4,14 @@
 **         |  Delphes, a framework for the fast simulation  |         **
 **         |       of a  generic collider experiment        |         **
-**          \----------------------------------------------/          **
+**          \-------------  arXiv:0903.2225v1  ------------/          **
 **                                                                    **
 **                                                                    **
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,15 +20,16 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/
+
 
 // \brief Trigger class, and some generic definitions
Index: trunk/src/VeryForward.cc
===================================================================
--- trunk/src/VeryForward.cc	(revision 434)
+++ trunk/src/VeryForward.cc	(revision 443)
@@ -9,7 +9,9 @@
 **   This package uses:                                               **
 **   ------------------                                               **
-**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      ** 
-**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       ** 
+**   ROOT: Nucl. Inst. & Meth. in Phys. Res. A389 (1997) 81-86        **
+**   FastJet algorithm: Phys. Lett. B641 (2006) [hep-ph/0512210]      **
+**   Hector: JINST 2:P09005 (2007) [physics.acc-ph:0707.1198v2]       **
 **   FROG: [hep-ex/0901.2718v1]                                       **
+**   HepMC: Comput. Phys. Commun.134 (2001) 41                        **
 **                                                                    **
 ** ------------------------------------------------------------------ **
@@ -18,13 +20,13 @@
 **   -------------                                                    **
 **                                                                    **
-**                Severine Ovyn                Xavier Rouby           ** 
-**          severine.ovyn@uclouvain.be      xavier.rouby@cern         ** 
-**                                                                    ** 
-**         Center for Particle Physics and Phenomenology (CP3)        ** 
-**                Universite catholique de Louvain (UCL)              **       
-**                     Louvain-la-Neuve, Belgium                      **            
+**                Severine Ovyn                Xavier Rouby           **
+**          severine.ovyn@uclouvain.be      xavier.rouby@cern         **
+**                                                                    **
+**         Center for Particle Physics and Phenomenology (CP3)        **
+**                Universite catholique de Louvain (UCL)              **
+**                     Louvain-la-Neuve, Belgium                      **
 **                                                                    **
 **                      Copyright (C) 2008-2009,                      **
-**                        All rights reserved.                        **  
+**                        All rights reserved.                        **
 **                                                                    **
 ***********************************************************************/